#TITLE=Cog
#INFO
;-------------------------------------------
; Cog syntax file for Jedi Knight
; [SaberMaster]
;-------------------------------------------
#SORT=n

#T=General Layout
^# ^!.cog
^#
^#
^#
^# []
^#==============================================================#
symbols



end
^#==============================================================#
code
^#------------------------------------------------------



^#------------------------------------------------------
end
#T=Header
^# ^!.cog
^#
^#
^#
^# []
^#==============================================================#

#T=Flags
flags=0x^!

#T=Symbols Section
symbols



end

#T=     divider
^#==============================================================#

#T=     symbols
symbols


#T=     int
int		^!				local

#T=     flex
flex		^!				local

#T=     float
float		^!				local

#T=     thing
thing		^!				local

#T=     template
template	^!				local

#T=     vector
vector	^!				local

#T=     sector
sector	^!				local

#T=     surface
surface	^!				local

#T=     sound
int		^!.wav			local

#T=     keyframe
keyframe	^!.key			local

#T=     model
model	^!.3do			local

#T=     ai
ai		^!.ai				local

#T=     cog
cog		^!				local

#T=     message
message
#T=     end

end

#T= 
 
#T=Code Section
//	Code Section
#T=     code
code

#T=     divider
^#------------------------------------------------------

#T=     end
end
#T= 
 
#T=Messages
message	^!

#T=     activate
activate:

#T=     activated
activated:

#T=     aievent
aievent:

#T=     arrived
arrived:

#T=     autoselect
autoselect:

#T=     blocked
blocked:

#T=     changed
changed:

#T=     created
created:

#T=     crossed
crossed:

#T=     damaged
damaged:

#T=     deactivated
deactivated:

#T=     deselected
deselected:

#T=     entered
entered:

#T=     exited
exited:

#T=     fire
fire:

#T=     global0
global0:

#T=     join
join:

#T=     killed
killed:

#T=     leave
leave:

#T=     loading
loading:

#T=     newplayer
newplayer:

#T=     pulse
pulse:

#T=     removed
removed:

#T=     respawn
respawn:

#T=     selected
selected:

#T=     shutdown
shutdown:

#T=     sighted
sighted:

#T=     skill
skill:

#T=     splash
splash:

#T=     startup
startup:

#T=     taken
taken:

#T=     timer
timer:

#T=     touched
touched:

#T=     trigger
trigger:

#T=     userx
user^!:

#T= 
 
#T=Operators
Operators
#T=     +	Addition
 + 
#T=     -	Subtraction
 - 
#T=     *	Multiplication
 * 
#T=     %	Modulo
 % 
#T=     -	Negation
 -
#T=     ==	Equal to
 == 
#T=     !=	Not equal to
 != 
#T=     >=	Greater than or equal to
 >= 
#T=     <=	Less than or equal to
 <= 
#T=     >	Greater than
 > 
#T=     <	Less than
 < 
#T=     !	Logical "not"
!
#T=     &&	Logical "and"
 && 
#T=     ||	Logical "or"
 || 
#T=     &	Bitwise "and"
 & 
#T=     |	Bitwise "or"
 | 
#T=     =	Assignment
 = 
#T= 
 
#T=Symbol Extensions
Symbol Extensions
#T=     local
local
#T=     nolink
nolink
#T=     linkid
linkid=
#T=     mask
mask=
#T=     desc
desc=
#T= 
 
#T=Keywords
Keywords
#T=     call
call
#T=     else
else
#T=     for
for(i=0; ^!; i=i+1)
#T=     if
if(^!)
#T=     Return
Return;
#T=     Stop
Stop;
#T=     while
while(^!)
#T=     do..while
do
{
	^!
}
while();
#T= 
 
#T=COG VERB SECTION:
COG VERB SECTION:
#T=  AI Verbs
  AI Verbs
#T=     AIClearMode
AIClearMode(^!, 0x);
#T=     AIFlee
AIFlee(^!, enemy);
#T=     AIGetMode
AIGetMode(^!)
#T=     AIGetMovePos
AIGetMovePos(^!) // Refer to the DM
#T=     AIJump
AIJump(^!, pos, 5.0);
#T=     AISetClass
AISetClass(^!, ai);
#T=     AISetFireTarget
AISetFireTarget(^!, target);
#T=     AISetLookPos
AISetLookPos(^!, pos);
#T=     AISetMode
AISetMode(^!, 0x);
#T=     AISetMovePos
AISetMovePos(^!, pos);
#T=     AISetMoveSpeed
AISetMoveSpeed(^!, speed);
#T=     AISetMoveThing
AISetMoveThing(^!, target);
#T=     GetActorWeapon
GetActorWeapon(^!, weapNum)
#T=     IsAiTargetInSight
IsAITargetInSight(^!)
#T=     SetActorWeapon
SetActorWeapon(^!, weapNum, tpl);
#T= 
 
#T=  Anim / Cel Verbs
  Anim / Cel Verbs
#T=     GetMaterialCel
GetMaterialCel(^!)
#T=     MaterialAnim
MaterialAnim(^!, cps, 0x);
#T=     SetMaterialCel
SetMaterialCel(^!, celNum);
#T=     GetSurfaceAnim
GetSurfaceAnim(^!)
#T=     GetSurfaceCel
GetSurfaceCel(^!)
#T=     GetWallCel
GetWallCel(^!)
#T=     SetSurfaceCel
SetSurfaceCel(^!, celNum);
#T=     SetWallCel
SetWallCel(^!, celNum);
#T=     StopSurfaceAnim
StopSurfaceAnim(^!);
#T=     SurfaceAnim
SurfaceAnim(^!, cps, 0x);
#T=     SlideCeilingSky
SlideCeilingSky(^!uSpeed, vSpeed);
#T=     SlideHorizonSky
SlideHorizonSky(^!uSpeed, vSpeed);
#T=     SlideSurface
SlideSurface(^!, vec, speed);
#T=     SlideWall
SlideWall(^!, vec, speed);
#T=     StopAnim
StopAnim(^!);
#T=     SurfaceLightAnim
SurfaceLightAnim(^!, startLight, endLight, time);
#T= 
 
#T=  Camera Verbs
  Camera Verbs
#T=     CycleCamera
CycleCamera();
#T=     GetCameraStateFlags
GetCameraStateFlags()
#T=     GetCurrentCamera
GetCurrentCamera()
#T=     GetPrimaryFocus
GetPrimaryFocus(^!cam)
#T=     GetSecondaryFocus
GetSecondaryFocus(^!) // Refer to the DM
#T=     SetCameraFocus
SetCameraFocus(^!cam, thing);
#T=     SetCameraStateFlags
SetCameraStateFlags(0x^!);
#T=     SetCurrentCamera
SetCurrentCamera(^!);
#T=     SetPOVShake
SetPOVShake(^!posOffset, angleOffset, posResetSpeed, angleResetSpeed);
#T= 
 
#T=  Color Verbs
  Color Verbs
#T=     AddDynamicAdd
AddDynamicAdd(^!player, rInt, gInt, bInt);
#T=     AddDynamicTint
AddDynamicTint(^!player, rFlex, gFlex, bFlex);
#T=     FreeColorEffect
FreeColorEffect(^!handle);
#T=     ModifyColorEffect
ModifyColorEffect(^!handle); // Refer to the DM
#T=     NewColorEffect
NewColorEffect(^!rInt1, gInt1, bInt1, rFlex2, gFlex2, bFlex2, rInt3, gInt3, bInt3, flexBlack);
#T= 
 
#T=  Creature Verbs
  Creature Verbs
#T=     GetHeadLightIntensity
GetHeadLightIntensity(^!) // Refer to the DM
#T=     GetHealth
GetHealth(^!)
#T=     GetThingHealth
GetThingHealth(^!)
#T=     HasLOS
HasLOS(^!, target)
#T=     HealThing
HealThing(^!, health);
#T=     IsCrouching
IsCrouching(^!)
#T=     IsThingCrouching
IsThingCrouching(^!)
#T=     jkClearFlags
jkClearFlags(^!, 0x);
#T=     jkGetFlags
jkGetFlags(^!)
#T=     jkSetFlags
jkSetFlags(^!, 0x);
#T=     jkSetInvis
jkSetInvis(^!, bool);
#T=     jkSetInvulnerable
jkSetInvulnerable(^!, bool);
#T=     SetActorExtraSpeed
SetActorExtraSpeed(^!, speed);
#T=     SetHeadLightIntensity
SetHeadLightIntensity(^!, light); // Refer to the DM
#T=     SetHealth
SetHealth(^!, health);
#T=     SetThingHealth
SetThingHealth(^!, health);
#T= 
 
#T=  Frame Verbs
  Frame Verbs
#T=     AISetLookFrame
AISetLookFrame(^!, frame);
#T=     AISetMoveFrame
AISetMoveFrame(^!, frame);
#T=     GetCurFrame
GetCurFrame(^!)
#T=     GetGoalFrame
GetGoalFrame(^!)
#T=     JumpToFrame
JumpToFrame(^!, frame, sec);
#T=     MoveToFrame
MoveToFrame(^!, frame, speed);
#T=     PathMovePause
PathMovePause(^!);
#T=     PathMoveResume
PathMoveResume(^!);
#T=     SkipToFrame
SkipToFrame(^!, frame, speed);
#T=     WaitForStop
WaitForStop(^!);
#T=     Rotate
Rotate(^!, rotvel);
#T=     RotatePivot
RotatePivot(^!, frame, time);
#T= 
 
#T=  Inventory Verbs
  Inventory Verbs
#T=     ChangeInv
ChangeInv(^!player, bin, amount);
#T=     GetInv
GetInv(^!player, bin)
#T=     GetInvCog
GetInvCog(^!player, bin)
#T=     GetInvMax
GetInvMax(^!player, bin)
#T=     GetInvMin
GetInvMin(^!player, bin)
#T=     IsInvActivated
IsInvActivated(^!player, bin)
#T=     IsInvAvailable
IsInvAvailable(^!player, bin)
#T=     SetBinWait
SetBinWait(^!player, bin, time);
#T=     SetInv
SetInv(^!player, bin, amount);
#T=     SetInvActivated
SetInvActivated(^!player, bin, bool);
#T=     SetInvAvailable
SetInvAvailable(^!player, bin, bool);
#T=     SetInvFlags
SetInvFlags(^!player, bin, 0x);
#T= 
 
#T=  Keyframe Verbs
  Keyframe Verbs
#T=     GetKeyLen
GetKeyLen(^!)
#T=     GetMajorMode
GetMajorMode(^!)
#T=     jkPlayPOVKey
jkPlayPOVKey(^!player, key, priority, 0x);
#T=     jkStopPOVKey
jkStopPOVKey(^!player, animID, delay);
#T=     PlayKey
PlayKey(^!, key, priority, 0x);
#T=     PlayMode
PlayMode(^!, submode);
#T=     StopKey
StopKey(^!, animID, delay);
#T= 
 
#T=  Level Verbs
  Level Verbs
#T=     AutoSaveGame
AutoSaveGame();
#T=     GetCeilingSkyOffset
GetCeilingSkyOffset()
#T=     GetFlexGameTime
GetFlexGameTime()
#T=     GetGameTime
GetGameTime()
#T=     GetGravity
GetGravity()
#T=     GetHorizonSkyOffset
GetHorizonSkyOffset()
#T=     GetLevelTime
GetLevelTime()
#T=     GetSectorCount
GetSectorCount()
#T=     GetSurfaceCount
GetSurfaceCount()
#T=     GetThingCount
GetThingCount()
#T=     GetThingTemplateCount
GetThingTemplateCount(^!tpl)
#T=     jkEndLevel
jkEndLevel(bool);
#T=     SetCeilingSkyOffset
SetCeilingSkyOffset(^!u, v); // Refer to the DM
#T=     SetGravity
SetGravity(^!);
#T=     SetHorizonSkyOffset
SetHorizonSkyOffset(^!u, v); // Refer to the DM
#T= 
 
#T=  Message Verbs
  Message Verbs
#T=     GetParam
GetParam(^!)
#T=     GetSenderID
GetSenderID()
#T=     GetSenderRef
GetSenderRef()
#T=     GetSenderType
GetSenderType()
#T=     GetSourceRef
GetSourceRef()
#T=     GetSourceType
GetSourceType()
#T=     KillTimerEx
KillTimerEx(^!);
#T=     ReturnEx
ReturnEx(^!);
#T=     SendMessage
SendMessage(^!cog, msg);
#T=     SendMessageEx
SendMessageEx(^!cog, msg, 0, 0, 0, 0);
#T=     SendTrigger
SendTrigger(^!dest, id, 0, 0, 0, 0);
#T=     SetParam
SetParam(^!, flex);
#T=     SetPulse
SetPulse(^!);
#T=     SetTimer
SetTimer(^!);
#T=     SetTimerEx
SetTimerEx(^!delay, id, 0, 0);
#T=     Sleep
Sleep(^!);
#T=     SetThingPulse
SetThingPulse(^!, delay);
#T=     SetThingTimer
SetThingTimer(^!, delay);
#T= 
 
#T=  Misc Verbs
  Misc Verbs
#T=     AmputateJoint
AmputateJoint(^!, jointNum);
#T=     DisableIRMode
DisableIRMode();
#T=     EnableIRMode
EnableIRMode(^!levelLight, thingLight);
#T=     GetSithMode
GetSithMode();^! // Refer to the DM
#T=     jkDisableSaber
jkDisableSaber(^!);
#T=     jkEnableSaber
jkEnableSaber(^!, dmg, length, 0.25);
#T=     jkEndTarget
jkEndTarget();
#T=     jkSetPersuasionInfo
jkSetPersuasionInfo(^!, minStars, maxStars);
#T=     jkSetSaberInfo
jkSetSaberInfo(^!, sideMat, tipMat, baseRad, tipRad, length, wallTpl, bloodTpl, saberTpl);
#T=     jkSetTarget
jkSetTarget(^!);
#T=     jkSetTargetColors
jkSetTargetColors(^!color1, color2, color3);
#T=     ParseArg
ParseArg(^!, "=");
#T=     SkillTarget
SkillTarget(^!target, source, param0, param1);
#T=     TakeItem
TakeItem(^!item, player);
#T=     ThingViewDot
ThingViewDot(^!viewer, target)
#T= 
 
#T=  Multiplayer Verbs
  Multiplayer Verbs
#T=     ClearMultiModeFlags
ClearMultiModeFlags(0x^!);
#T=     CreateBackpack
CreateBackpack(^!player);
#T=     GetAbsoluteMaxPlayers
GetAbsoluteMaxPlayers()
#T=     GetMaxPlayers
GetMaxPlayers()
#T=     GetMultiModeFlags
GetMultiModeFlags()
#T=     GetNumPlayers
GetNumPlayers()
#T=     GetNumPlayersInTeam
GetNumPlayersInTeam(^!)
#T=     GetPlayerTeam
GetPlayerTeam(^!)
#T=     GetRespawnMask
GetRespawnMask(^!player)
#T=     GetTimeLimit
GetTimeLimit()
#T=     IsMulti
IsMulti()
#T=     IsServer
IsServer()
#T=     NthBackpackBin
NthBackpackBin(^!pack, itemNum)
#T=     NthBackpackValue
NthBackpackValue(^!pack, itemNum)
#T=     NumBackpackItems
NumBackpackItems(^!)
#T=     PickupBackpack
PickupBackpack(^!player, pack);
#T=     SetMultiModeFlags
SetMultiModeFlags(0x^!);
#T=     SetPlayerTeam
SetPlayerTeam(^!, team);
#T=     SetRespawnMask
SetRespawnMask(^!player, 0x);
#T=     SetTimeLimit
SetTimeLimit(^!mins);
#T=     SyncScores
SyncScores();
#T=     SyncSector
SyncSector(^!);
#T=     SyncSurface
SyncSurface(^!);
#T=     SyncThingAttachment
SyncThingAttachment(^!);
#T=     SyncThingPos
SyncThingPos(^!);
#T=     SyncThingState
SyncThingState(^!);
#T= 
 
#T=  Option Verbs
  Option Verbs
#T=     GetAutoPickup
GetAutoPickup()
#T=     GetAutoReload
GetAutoReload()
#T=     GetAutoSwitch
GetAutoSwitch()
#T=     GetDifficulty
GetDifficulty()
#T=     jkGetSaberCam
jkGetSaberCam()
#T=     SetAutoPickup
SetAutoPickup(^!player, 0x); // Refer to the DM
#T=     SetAutoReload
SetAutoReload(^!player, 0x); // Refer to the DM
#T=     SetAutoSwitch
SetAutoSwitch(^!player, 0x);
#T= 
 
#T=  Particle Verbs
  Particle Verbs
#T=     GetParticleGrowthSpeed
GetParticleGrowthSpeed(^!)
#T=     GetParticleSize
GetParticleSize(^!)
#T=     GetParticleTimeoutRate
GetParticleTimeoutRate(^!)
#T=     SetParticleGrowthSpeed
SetParticleGrowthSpeed(^!, speed);
#T=     SetParticleSize
SetParticleSize(^!, jkuSize); // Refer to the DM
#T=     SetParticleTimeoutRate
SetParticleTimeoutRate(^!, rate);
#T= 
 
#T=  Player Verbs
  Player Verbs
#T=     ClearGoalFlags
ClearGoalFlags(^!player, goalNum, 0x);
#T=     GetLocalPlayerThing
GetLocalPlayerThing()
#T=     GetPlayerNum
GetPlayerNum(^!)
#T=     GetPlayerThing
GetPlayerThing(^!num)
#T=     jkClearSuperFlags
jkClearSuperFlags(0x^!);
#T=     jkGetChoice
jkGetChoice()
#T=     jkGetLocalPlayer
jkGetLocalPlayer()
#T=     jkGetSuperFlags
jkGetSuperFlags()
#T=     jkSetForceSpeed
jkSetForceSpeed(^!speed);
#T=     jkSetSuperFlags
jkSetSuperFlags(0x^!);
#T=     SetGoalFlags
SetGoalFlags(^!player, goalNum, 0x);
#T= 
 
#T=  Print Verbs
  Print Verbs
#T=     jkPrintUniString
jkPrintUniString(^!dest, uniNum);
#T=     jkStringClear
jkStringClear();
#T=     jkStringConcatAsciiString
jkStringConcatAsciiString("^!");
#T=     jkStringConcatFlex
jkStringConcatFlex(^!);
#T=     jkStringConcatFormattedFlex
jkStringConcatFormattedFlex(^!, " %f");
#T=     jkStringConcatFormattedInt
jkStringConcatFormattedInt(^!, " %d");
#T=     jkStringConcatInt
jkStringConcatInt(^!);
#T=     jkStringConcatPlayerName
jkStringConcatPlayerName(^!);
#T=     jkStringConcatSpace
jkStringConcatSpace();
#T=     jkStringConcatUniString
jkStringConcatUniString(^!);
#T=     jkStringConcatVector
jkStringConcatVector(^!);
#T=     jkStringOutput
jkStringOutput(^!-1, -1);
#T=     Print
Print("^!");
#T=     PrintFlex
PrintFlex(^!);
#T=     PrintInt
PrintInt(^!);
#T=     PrintVector
PrintVector(^!);
#T= 
 
#T=  Score Verbs
  Score Verbs
#T=     AddScoreToTeamMembers
AddScoreToTeamMembers(^!team, score);
#T=     GetPlayerKilled
GetPlayerKilled(^!)
#T=     GetPlayerKills
GetPlayerKills(^!)
#T=     GetPlayerScore
GetPlayerScore(^!)
#T=     GetPlayerSuicides
GetPlayerSuicides(^!)
#T=     GetScoreLimit
GetScoreLimit()
#T=     GetTeamScore
GetTeamScore(^!)
#T=     SetPlayerKilled
SetPlayerKilled(^!, beenKilled);
#T=     SetPlayerKills
SetPlayerKills(^!, kills);
#T=     SetPlayerScore
SetPlayerScore(^!, score);
#T=     SetPlayerSuicides
SetPlayerSuicides(^!, selfKills);
#T=     SetScoreLimit
SetScoreLimit(^!);
#T=     SetTeamScore
SetTeamScore(^!, score);
#T= 
 
#T=  Sector Verbs
  Sector Verbs
#T=     ClearSectorFlags
ClearSectorFlags(^!, 0x);
#T=     FirstThingInSector
FirstThingInSector(^!sec)
#T=     GetColormap
GetColormap(^!sec)
#T=     GetNumSectorSurfaces
GetNumSectorSurfaces(^!)
#T=     GetNumSectorVertices
GetNumSectorVertices(^!)
#T=     GetSectorCenter
GetSectorCenter(^!)
#T=     GetSectorColormap
GetSectorColormap(^!)
#T=     GetSectorFlags
GetSectorFlags(^!)
#T=     GetSectorLight
GetSectorLight(^!)
#T=     GetSectorPlayerCount
GetSectorPlayerCount(^!)
#T=     GetSectorSurfaceRef
GetSectorSurfaceRef(^!sec, surfNum)
#T=     GetSectorThingCount
GetSectorThingCount(^!)
#T=     GetSectorThrust
GetSectorThrust(^!)
#T=     GetSectorTint
GetSectorTint(^!)
#T=     GetSectorVertexPos
GetSectorVertexPos(^!sec, vertNum)
#T=     NextThingInSector
NextThingInSector(^!thing)
#T=     PrevThingInSector
PrevThingInSector(^!thing)
#T=     SectorAdjoins
SectorAdjoins(^!, bool);
#T=     SectorLight
SectorLight(^!, light, delay);
#T=     SectorPlayerCount
SectorPlayerCount(^!)
#T=     SectorThrust
SectorThrust(^!, vec, speed);
#T=     SectorThingCount
SectorThingCount(^!)
#T=     SetColormap
SetColormap(^!sec,  cmp);
#T=     SetSectorAdjoins
SetSectorAdjoins(^!, bool);
#T=     SetSectorColormap
SetSectorColormap(^!, cmp);
#T=     SetSectorFlags
SetSectorFlags(^!, 0x);
#T=     SetSectorLight
SetSectorLight(^!, light, delay);
#T=     SetSectorThrust
SetSectorThrust(^!, vec, speed);
#T=     SetSectorTint
SetSectorTint(^!, 'r g b');
#T= 
 
#T=  Sound Verbs
  Sound Verbs
#T=     ChangeSoundPitch
ChangeSoundPitch(^!chnl, pitch, delay);
#T=     ChangeSoundVol
ChangeSoundVol(^!chnl, vol, delay);
#T=     GetSoundLen
GetSoundLen(^!)
#T=     PlaySong
PlaySong(^!start, end, loopto);
#T=     PlaySoundClass
PlaySoundClass(^!thing, subclass);
#T=     PlaySoundGlobal
PlaySoundGlobal(^!wav, vol, pan, 0x);
#T=     PlaySoundLocal
PlaySoundLocal(^!wav, vol, pan, 0x);
#T=     PlaySoundPos
PlaySoundPos(^!wav, pos, vol, minrad, maxrad, 0x);
#T=     PlaySoundThing
PlaySoundThing(^!wav, thing, vol, minrad, maxrad, 0x);
#T=     SectorSound
SectorSound(^!sec, wav, vol);
#T=     SetMusicVol
SetMusicVol(^!vol); // Refer to the DM
#T=     StopSound
StopSound(^!chnl, delay);
#T= 
 
#T=  Special Flag Verbs
  Special Flag Verbs
#T=     ClearDebugModeFlags
ClearDebugModeFlags(0x^!);
#T=     ClearMapModeFlags
ClearMapModeFlags(0x^!);
#T=     ClearSubModeFlags
ClearSubModeFlags(0x^!);
#T=     GetDebugModeFlags
GetDebugModeFlags()
#T=     GetMapModeFlags
GetMapModeFlags()
#T=     GetSubModeFlags
GetSubModeFlags()
#T=     SetDebugModeFlags
SetDebugModeFlags(0x^!);
#T=     SetMapModeFlags
SetMapModeFlags(0x^!);
#T=     SetSubModeFlags
SetSubModeFlags(0x^!);
#T= 
 
#T=  Surface Verbs
  Surface Verbs
#T=     ClearAdjoinFlags
ClearAdjoinFlags(^!, 0x);
#T=     ClearFaceType
ClearFaceType(^!, 0x);
#T=     ClearSurfaceFlags
ClearSurfaceFlags(^!, 0x);
#T=     GetAdjoinFlags
GetAdjoinFlags(^!)
#T=     GetFaceGeoMode
GetFaceGeoMode(^!)
#T=     GetFaceLightMode
GetFaceLightMode(^!)
#T=     GetFaceTexMode
GetFaceTexMode(^!)
#T=     GetFaceType
GetFaceType(^!)
#T=     GetNumSurfaceVertices
GetNumSurfaceVertices(^!)
#T=     GetSurfaceAdjoin
GetSurfaceAdjoin(^!adjoin);
#T=     GetSurfaceCenter
GetSurfaceCenter(^!)
#T=     GetSurfaceFlags
GetSurfaceFlags(^!)
#T=     GetSurfaceLight
GetSurfaceLight(^!)
#T=     GetSurfaceMat
GetSurfaceMat(^!)
#T=     GetSurfaceNormal
GetSurfaceNormal(^!)
#T=     GetSurfaceSector
GetSurfaceSector(^!)
#T=     GetSurfaceVertexPos
GetSurfaceVertexPos(^!surf, vertNum)
#T=     SetAdjoinFlags
SetAdjoinFlags(^!, 0x);
#T=     SetFaceGeoMode
SetFaceGeoMode(^!, mode);
#T=     SetFaceLightMode
SetFaceLightMode(^!, mode);
#T=     SetFaceTexMode
SetFaceTexMode(^!, mode);
#T=     SetFaceType
SetFaceType(^!, 0x);
#T=     SetSurfaceFlags
SetSurfaceFlags(^!, 0x);
#T=     SetSurfaceLight
SetSurfaceLight(^!, light, delay);
#T=     SetSurfaceMat
SetSurfaceMat(^!, mat);
#T=     SurfaceCenter
SurfaceCenter(^!)
#T=     SurfaceLight
SurfaceLight(^!, light, delay);
#T= 
 
#T=  System Verbs
  System Verbs
#T=     BitClear
BitClear(^!, 0x)
#T=     BitSet
BitSet(^!, 0x)
#T=     BitTest
BitTest(^!, 0x)
#T=     GetMasterCog
GetMasterCog()
#T=     GetSelfCog
GetSelfCog()
#T=     HeapFree
HeapFree();
#T=     HeapGet
HeapGet(^!pointer)
#T=     HeapNew
HeapNew(^!startNum, endNum);
#T=     HeapSet
HeapSet(^!pointer, flex);
#T=     LoadKeyframe
LoadKeyframe("^!.key")
#T=     LoadModel
LoadModel("^!.3do")
#T=     LoadSound
LoadSound("^!.wav")
#T=     LoadTemplate
LoadTemplate("^!")
#T=     Rand
Rand()
#T=     Reset
Reset();
#T=     SetMasterCog
SetMasterCog(^!cog);
#T= 
 
#T=  Thing Action Verbs
  Thing Action Verbs
#T=     AttachThingToSurf
AttachThingToSurf(^!, surf); // Refer to the DM
#T=     AttachThingtoThing
AttachThingtoThing(^!, base);
#T=     AttachThingtoThingEx
AttachThingtoThingEx(^!, base, 0x);
#T=     CaptureThing
CaptureThing(^!);
#T=     CreateThing
CreateThing(^!tpl, thing);
#T=     CreateThingAtPos
CreateThingAtPos(^!tpl, sec, pos, '0 0 0');
#T=     CreateThingAtPosNR
CreateThingAtPosNR(^!tpl, sec, pos, '0 0 0');
#T=     CreateThingNR
CreateThingNR(^!tpl, thing);
#T=     DamageThing
DamageThing(^!, dmg, 0x, dmgr);
#T=     DestroyThing
DestroyThing(^!);
#T=     DetachThing
DetachThing(^!);
#T=     FirstThingInView
FirstThingInView(^!, fov, dist, 0x)
#T=     GetThingLVec
GetThingLVec(^!)
#T=     GetThingPos
GetThingPos(^!)
#T=     GetThingRVec
GetThingRVec(^!)
#T=     GetThingUVec
GetThingUVec(^!)
#T=     IsMoving
IsMoving(^!)
#T=     IsThingMoving
IsThingMoving(^!)
#T=     IsThingVisible
IsThingVisible(^!)
#T=     NextThingInView
NextThingInView()
#T=     ReleaseThing
ReleaseThing(^!);
#T=     SetThingLook
SetThingLook(^!, vec);
#T=     SetThingPos
SetThingPos(^!, pos);
#T=     TeleportThing
TeleportThing(^!, thing);
#T=     ThingLightAnim
ThingLightAnim(^!, minLight, maxLight, time);
#T= 
 
#T=  Thing Flag Verbs
  Thing Flag Verbs
#T=     ClearActorFlags
ClearActorFlags(^!, 0x);
#T=     ClearExplosionFlags
ClearExplosionFlags(^!, 0x);
#T=     ClearItemFlags
ClearItemFlags(^!, 0x);
#T=     ClearParticleFlags
ClearParticleFlags(^!, 0x);
#T=     ClearPhysicsFlags
ClearPhysicsFlags(^!, 0x);
#T=     ClearThingAttachFlags
ClearThingAttachFlags(^!, 0x);
#T=     ClearThingFlags
ClearThingFlags(^!, 0x);
#T=     ClearTypeFlags
ClearTypeFlags(^!, 0x);
#T=     ClearWeaponFlags
ClearWeaponFlags(^!, 0x);
#T=     GetActorFlags
GetActorFlags(^!)
#T=     GetAttachFlags
GetAttachFlags(^!)
#T=     GetExplosionFlags
GetExplosionFlags(^!)
#T=     GetItemFlags
GetItemFlags(^!)
#T=     GetParticleFlags
GetParticleFlags(^!)
#T=     GetPhysicsFlags
GetPhysicsFlags(^!)
#T=     GetThingAttachFlags
GetThingAttachFlags(^!)
#T=     GetThingFlags
GetThingFlags(^!)
#T=     GetTypeFlags
GetTypeFlags(^!)
#T=     GetWeaponFlags
GetWeaponFlags(^!)
#T=     SetActorFlags
SetActorFlags(^!, 0x);
#T=     SetExplosionFlags
SetExplosionFlags(^!, 0x);
#T=     SetItemFlags
SetItemFlags(^!, 0x);
#T=     SetParticleFlags
SetParticleFlags(^!, 0x);
#T=     SetPhysicsFlags
SetPhysicsFlags(^!, 0x);
#T=     SetThingAttachFlags
SetThingAttachFlags(^!, 0x);
#T=     SetThingFlags
SetThingFlags(^!, 0x);
#T=     SetTypeFlags
SetTypeFlags(^!, 0x);
#T=     SetWeaponFlags
SetWeaponFlags(^!, 0x);
#T= 
 
#T=  Thing Mode Verbs
  Thing Mode Verbs
#T=     GetThingCurGeoMode
GetThingCurGeoMode(^!)
#T=     GetThingCurLightMode
GetThingCurLightMode(^!)
#T=     GetThingCurTexMode
GetThingCurTexMode(^!) // Refer to the DM
#T=     GetThingGeoMode
GetThingGeoMode(^!)
#T=     GetThingLightMode
GetThingLightMode(^!)
#T=     GetThingTexMode
GetThingTexMode(^!) // Refer to the DM
#T=     SetThingCurGeoMode
SetThingCurGeoMode(^!, mode);
#T=     SetThingCurLightMode
SetThingCurLightMode(^!, mode); // Refer to the DM
#T=     SetThingCurTexMode
SetThingCurTexMode(^!, mode); // Refer to the DM
#T=     SetThingGeoMode
SetThingGeoMode(^!, mode);
#T=     SetThingLightMode
SetThingLightMode(^!, mode);
#T=     SetThingTexMode
SetThingTexMode(^!, mode); // Refer to the DM
#T= 
 
#T=  Thing Property Verbs
  Thing Property Verbs
#T=     GetCollideType
GetCollideType(^!)
#T=     GetLifeLeft
GetLifeLeft(^!)
#T=     GetThingCaptureCog
GetThingCaptureCog(^!)
#T=     GetThingClassCog
GetThingClassCog(^!)
#T=     GetThingCollideSize
GetThingCollideSize(^!)
#T=     GetThingFireOffset
GetThingFireOffset(^!)
#T=     GetThingLight
GetThingLight(^!)
#T=     GetThingMass
GetThingMass(^!)
#T=     GetThingModel
GetThingModel(^!)
#T=     GetThingMoveSize
GetThingMoveSize(^!)
#T=     GetThingParent
GetThingParent(^!)
#T=     GetThingRespawn
GetThingRespawn(^!)
#T=     GetThingSector
GetThingSector(^!)
#T=     GetThingSignature
GetThingSignature(^!)
#T=     GetThingTemplate
GetThingTemplate(^!)
#T=     GetThingType
GetThingType(^!)
#T=     GetThingUserData
GetThingUserData(^!)
#T=     SetCollideType
SetCollideType(^!, type);
#T=     SetLifeLeft
SetLifeLeft(^!, time);
#T=     SetThingCaptureCog
SetThingCaptureCog(^!, cog);
#T=     SetThingClassCog
SetThingClassCog(^!, cog);
#T=     SetThingCollideSize
SetThingCollideSize(^!, jkuSize);
#T=     SetThingFireOffset
SetThingFireOffset(^!, '0 0 0');
#T=     SetThingLight
SetThingLight(^!, light, time);
#T=     SetThingMass
SetThingMass(^!, mass);
#T=     SetThingModel
SetThingModel(^!, mdl);
#T=     SetThingMoveSize
SetThingMoveSize(^!, jkuSize);
#T=     SetThingType
SetThingType(^!, type);
#T=     SetThingUserData
SetThingUserData(^!, flex);
#T=     ThingLight
ThingLight(^!, light, time);
#T= 
 
#T=  Vector Verbs
  Vector Verbs
#T=     RandVec
RandVec()
#T=     VectorAdd
VectorAdd(^!vec, vec)
#T=     VectorCross
VectorCross(^!vec, vec)
#T=     VectorDist
VectorDist(^!vec, vec)
#T=     VectorDot
VectorDot(^!vec, vec)
#T=     VectorLen
VectorLen(^!)
#T=     VectorNorm
VectorNorm(^!)
#T=     VectorScale
VectorScale(^!vec, flex)
#T=     VectorSet
VectorSet(^!x, y, z)
#T=     VectorSub
VectorSub(^!vec, vec)
#T=     VectorX
VectorX(^!)
#T=     VectorY
VectorY(^!)
#T=     VectorZ
VectorZ(^!)
#T= 
 
#T=  Velocity Verbs
  Velocity Verbs
#T=     AddThingVel
AddThingVel(^!, vel);
#T=     ApplyForce
ApplyForce(^!, vec);
#T=     GetThingRotVel
GetThingRotVel(^!)
#T=     GetThingThrust
GetThingThrust(^!)
#T=     GetThingVel
GetThingVel(^!)
#T=     SetThingRotVel
SetThingRotVel(^!, rotvel);
#T=     SetThingThrust
SetThingThrust(^!, vec);
#T=     SetThingVel
SetThingVel(^!, vel);
#T=     StopThing
StopThing(^!);
#T= 
 
#T=  Weapon Verbs
  Weapon Verbs
#T=     ActivateBin
ActivateBin(^!player, firewait, bin);
#T=     ActivateWeapon
ActivateWeapon(^!player, firewait, mode);
#T=     AssignWeapon
AssignWeapon(^!player, bin);
#T=     AutoselectWeapon
AutoselectWeapon(^!player, mode);
#T=     ChangeFireRate
ChangeFireRate(^!player, firewait);
#T=     DeactivateBin
DeactivateBin(^!player, bin);
#T=     DeactivateWeapon
DeactivateWeapon(^!player, mode);
#T=     FireProjectile
FireProjectile(^!thing, tpl, snd, mode, '0 0 0', '0 0 0', 0, 0x0, 0, 0);
#T=     GetCurInvWeapon
GetCurInvWeapon(^!player)
#T=     GetCurWeapon
GetCurWeapon(^!player)
#T=     GetCurWeaponMode
GetCurWeaponMode()
#T=     GetWeaponPriority
GetWeaponPriority(^!player, bin, mode)
#T=     jkSetPOVModel
jkSetPOVModel(^!player, povMdl);
#T=     jkSetWaggle
jkSetWaggle(^!player, '0 0 0', speed);
#T=     jkSetWeaponMesh
jkSetWeaponMesh(^!player, extMdl);
#T=     SelectWeapon
SelectWeapon(^!player, bin);
#T=     SetArmedMode
SetArmedMode(^!player, mode);
#T=     SetCurInvWeapon
SetCurInvWeapon(^!player, bin);
#T=     SetCurWeapon
SetCurWeapon(^!player, bin);
#T=     SetFireWait
SetFireWait(^!player, firewait);
#T=     SetMountWait
SetMountWait(^!player, delay);
#